//
//      archpi.cpp - Compute pi by the Archimedean method,
//		     Fix pi between upper and lower sums,
// (2**(n+2))*sin( pi/(4*(2**n)) )  < pi <
//                                      (2**(n+2))*tan( pi/(4*(2**n)) )  
//
//                      - Author: James A. Green.
//			- Compiler: Borland C/C++
//
//
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
main()
{
	double pi0 = 3.141592653589793;  //the known value of pi.
	double plow;        // plow = 2**(n+2).
	double lowval;      // lower value for pi limit (sine value).
	
	double highval;   // higher value for pi limit (tangent value).
	double power(double a, int m); // a**m
	int n;		// the number of straight line segs = 2**n
	int more = 1;

     while(more == 1){
	printf("Archpi - Compute pi by the Archimedean method:\n");
	printf("     Fix it between upper and lower sums of 2**N \n");
	printf("     line segments per quadrant, using\n");
	printf("     (2**(n+2))*sin(pi/(4*(2**n))) < pi,\n");
	printf("      pi < (2**(n+2))*tan(pi/(4*(2**n))).\n");
	printf("      Archimedes used sine and tangent tables\n");
	printf("      computed by an algebraic technique with\n");
	printf("      arbitary accuracy. Quick convergence when N > 8.\n\n");  
	printf("Enter N < 100, for 2**N  steps along pi/2 of arc:");
	scanf("%d",&n);
	printf("\n");
	if(n == 0 || n < 0){
	   printf("The minimum number of steps is 2 = 2**1, N = 1.\n");
	   exit(0);
	}
	plow = power(2.0, n+2);
	lowval = plow*sin(pi0/plow);
	highval = plow*tan(pi0/plow);
	printf("N = %d for 2**N = %f line segments\n", n, power(2.0, n));
	printf("lowval = %1.15f < pi < %1.15f = highval\n\n", lowval, highval);
	printf("Pi is known = 3.141592653589793...\n\n");

     	printf("Enter 1 to continue or 0 to exit:");
	scanf("%d", &more);
	printf("\n");
	if(more == 0) exit;
     }
     printf("End Archpi, Calculation of pi via the method of\n");
     printf("            Archimedes of Syracuse.\n\n");

}
//
// power(a,m) = a**m
//
double power(double a, int m)
{
	double v;
	int i;

	v = 1.00000;
	if(m == 0) return(1.0);
	for(i=0 ; i < m; i++){
	   v = v*a;
	}
        return(v);
}




































































































































































































































































































































































































































































































